'  SOI 2015 Creative Task 'Bazaar'
'
'  Sample bot in VB.NET.
'  contact: sebastian@soi.ch

Imports System
Imports System.Text

Module Bot
  '  Game configuration.
  Dim n, a, d, g, bids(), players() as Integer

  '  Source of randomness.
  Dim shaker as Random = New Random()

  '  IO.
  Dim tokens(-1) as String
  Dim pos as Integer = 0
  Private Function nextInt() as Integer
    if pos >= tokens.Length Then
      tokens = Console.ReadLine().Split()
      pos = 0
    End If
    Dim next_int as Integer = tokens(pos)
    pos = pos + 1
    return next_int
  End Function

  Private Sub playAuction()
    '  Play a single auction.
    Dim i, round as Integer

    '  Distribute the available gold randomly.
    For i = 0 to d-1
      bids(i) = 0
    Next
    For i = 1 to g
      Dim pick as Integer = shaker.Next(0, d)
      bids(pick) = bids(pick) + 1
    Next

    '  Initialize players: each player starts with the same amount of gold.
    For i = 0 to n-1
      players(i) = g
    Next

    '  Play the auction.
    For round = 0 to d-1
      '  Place the bid.
      Console.WriteLine(bids(round))
      Console.Out.Flush()

      '  Keep track of every player's gold.
      players(0) = players(0) - bids(round)
      For i = 1 to n-1
        players(i) = players(i) - nextInt()
      Next 
    Next
  End Sub

  Sub Main()
    '  Initialize the bot.
    n = nextInt()
    a = nextInt()
    d = nextInt()
    g = nextInt()
    bids = new Integer(d) {}
    players = new Integer(n) {}

    '  Play all auctions.
    Dim auction as Integer
    For auction = 1 to a
      playAuction()
    Next
  End Sub
End Module